<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_ReferenciaProductoColor.xml */
/* Generado: 2024-08-02 05:22:56 */

/* Mantenimiento de los registros de la tabla MST_ReferenciaProductoColor */
abstract class BaseMST_ReferenciaProductoColorDP extends MST_ReferenciaProductoColorBV
{
    /* Constructor ( Establece los valores desde un objeto MST_ReferenciaProductoColorBN ) */
    public function __construct( MST_ReferenciaProductoColorBN $o_MST_ReferenciaProductoColorBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_ReferenciaProductoColorBN ) )
        {
            $this->setByBN( $o_MST_ReferenciaProductoColorBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_ReferenciaProductoColorBN */
    public function setByBN( MST_ReferenciaProductoColorBN $o_MST_ReferenciaProductoColorBN )
    {
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getIdReferencia() ) )
        {
            $this->setIdReferencia( $o_MST_ReferenciaProductoColorBN->getIdReferencia() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getIdColor() ) )
        {
            $this->setIdColor( $o_MST_ReferenciaProductoColorBN->getIdColor() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getImagenFlag() ) )
        {
            $this->setImagenFlag( $o_MST_ReferenciaProductoColorBN->getImagenFlag() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaNombre() ) )
        {
            $this->setImagenReferenciaNombre( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaNombre() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaFisico() ) )
        {
            $this->setImagenReferenciaFisico( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaFisico() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaWeb() ) )
        {
            $this->setImagenReferenciaWeb( $o_MST_ReferenciaProductoColorBN->getImagenReferenciaWeb() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_ReferenciaProductoColorBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_ReferenciaProductoColorBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_ReferenciaProductoColorBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_ReferenciaProductoColorBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_ReferenciaProductoColorBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_ReferenciaProductoColorFN = new MST_ReferenciaProductoColorFN();
        $o_MST_ReferenciaProductoColorBN = $o_MST_ReferenciaProductoColorFN->selectByPk( $this->getIdReferencia(), $this->getIdColor() );
        if ( is_null( $o_MST_ReferenciaProductoColorBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_ReferenciaProductoColor ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdReferencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdReferencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdReferencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdColor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdColor";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdColor()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImagenFlag";
                $s_SQLQuery2 .= $s_Separator."".$this->getImagenFlag()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImagenReferenciaNombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getImagenReferenciaNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaFisico() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImagenReferenciaFisico";
                $s_SQLQuery2 .= $s_Separator."'".$this->getImagenReferenciaFisico()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaWeb() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImagenReferenciaWeb";
                $s_SQLQuery2 .= $s_Separator."'".$this->getImagenReferenciaWeb()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_ReferenciaProductoColor SET ";
            $s_Separator = "";
            if ( !is_null( $this->getImagenFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."ImagenFlag = ".$this->getImagenFlag()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."ImagenReferenciaNombre = '".$this->getImagenReferenciaNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaFisico() ) )
            {
                $s_SQLQuery .= $s_Separator."ImagenReferenciaFisico = '".$this->getImagenReferenciaFisico()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImagenReferenciaWeb() ) )
            {
                $s_SQLQuery .= $s_Separator."ImagenReferenciaWeb = '".$this->getImagenReferenciaWeb()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdReferencia = ".$this->getIdReferencia()." AND  IdColor = ".$this->getIdColor().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_ReferenciaProductoColor WHERE  IdReferencia = ".$this->getIdReferencia()." AND  IdColor = ".$this->getIdColor().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>